//+------------------------------------------------------------------+
//|                                                       Errors.mq4 |
//|                                                         SnowBars |
//|                           https://www.mql5.com/ru/users/snowbars |
//+------------------------------------------------------------------+
#property copyright "SnowBars"
#property link      "https://www.mql5.com/ru/users/snowbars"
#property version   "1.00"
#property strict
#property indicator_chart_window
enum BASE_CORNER {Top,Bottom};
input BASE_CORNER CORNER=Bottom;//  (/)
//---
string StringError,MQL_name;
int G,E;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   MQL_name=MQLInfoString(MQL_PROGRAM_NAME);
   StringError=" ,  !";
   DrawButton("OK",StringError,0,19,(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),20,clrBlack,clrWhite,clrWhite,8);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll(0,MQL_name);
  }
//--------------------------------------------------------------------

void OnChartEvent(const int id,const long &x,const double &y,const string &sparam)
  {
   if(id==9){DrawButton("OK",StringError,0,19,(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),20,clrBlack,clrWhite,clrWhite,8);}
   if(id==CHARTEVENT_OBJECT_CLICK && sparam==MQL_name+"OK"){
      E=0;
      StringError=" ,  !";
      DrawButton("OK",StringError,0,19,(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),20,clrBlack,clrWhite,clrWhite,8);}
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   GLError(GetLastError());
   if(E!=0){DrawButton("OK",StringError+" - ,    ",0,19,(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),20,clrBlack,clrRed,clrRed,8);}
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//--------------------------------------------------------------------
void DrawButton(string name="Button",string text="Text",int x=0,int y=0,int width=20,int height=10,color BGCOLOR=clrGreen,color clrBORDER=clrWhite,color clrTXT=clrWhite,int TxtSize=8,int sub_window=0)
  {
   name=MQL_name+name;
   if(ObjectFind(0,name)<0)
     {
      ObjectCreate(0,name,OBJ_BUTTON,sub_window,0,0);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,clrBORDER);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,BGCOLOR);
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,TxtSize);
      ObjectSetInteger(0,name,OBJPROP_COLOR,clrTXT);
      ObjectSetString(0,name,OBJPROP_TEXT,text);
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      if(CORNER==1){ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_LOWER);}
      if(CORNER==0){ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);}
      ObjectSetInteger(0,name,OBJPROP_BACK,false);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,false);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
     }
   else
     {
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      if(CORNER==1)
        {
         ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_LOWER);
         ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
        }
      if(CORNER==0)
        {
         ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(0,name,OBJPROP_YDISTANCE,-1);
        }
      ObjectSetInteger(0,name,OBJPROP_COLOR,clrTXT);
      ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,clrBORDER);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,BGCOLOR);
      ObjectSetString(0,name,OBJPROP_TEXT,text);
     }
  }
//-------------------------------------------------------------------   
void GLError(int GLE)
  {
   if(GLE!=G)
     {E=GLE;
      G=GLE;
      switch(GLE)
        {
         case 1:  { StringError=" #"+DoubleToString(GLE,0)+",  ,   ";break; }
         case 2:  { StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 3:  { StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4:  { StringError=" #"+DoubleToString(GLE,0)+",   "; break;}
         case 5:  { StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 6:  { StringError=" #"+DoubleToString(GLE,0)+",     "; break;}
         case 7:  { StringError=" #"+DoubleToString(GLE,0)+",  "; break; }
         case 8:  { StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 9:  { StringError=" #"+DoubleToString(GLE,0)+",  ,   ";break;}
         case 64: { StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 65: { StringError=" #"+DoubleToString(GLE,0)+",   ";break; }
         case 128:{ StringError=" #"+DoubleToString(GLE,0)+",     ";break;   }
         case 129:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 130:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 131:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break; }
         case 132:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 133:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break; }
         case 134:{ StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 135:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break; }
         case 136:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 137:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break; }
         case 138:{ StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 139:{ StringError=" #"+DoubleToString(GLE,0)+",     ";break; }
         case 140:{ StringError=" #"+DoubleToString(GLE,0)+",   ";break; }
         case 141:{ StringError=" #"+DoubleToString(GLE,0)+",    ";break;      }
         case 145:{ StringError=" #"+DoubleToString(GLE,0)+",  ,       ";break;}
         case 146:{ StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 147:{ StringError=" #"+DoubleToString(GLE,0)+",      ";break; }
         case 148:{ StringError=" #"+DoubleToString(GLE,0)+",       ,  ";break;}
         case 149:{ StringError=" #"+DoubleToString(GLE,0)+",      ,   ";break;}
         case 150:{ StringError=" #"+DoubleToString(GLE,0)+",          FIFO";break;}
         case 4001:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4002:{StringError=" #"+DoubleToString(GLE,0)+",   -  ";break;}
         case 4003:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4004:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4005:{StringError=" #"+DoubleToString(GLE,0)+",       ";break;}
         case 4006:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4007:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4008:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4009:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4010:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4011:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4012:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4013:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4014:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4015:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4016:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4017:{StringError=" #"+DoubleToString(GLE,0)+",  DLL  ";break;}
         case 4018:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4019:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4020:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 4021:{StringError=" #"+DoubleToString(GLE,0)+",    ,   ";break;}
         case 4022:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4023:{StringError=" #"+DoubleToString(GLE,0)+",    DLL-";break;}
         case 4024:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4025:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4026:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4027:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4028:{StringError=" #"+DoubleToString(GLE,0)+",       ";break;}
         case 4029:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4030:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4050:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4051:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4052:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4053:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4054:{StringError=" #"+DoubleToString(GLE,0)+",   -";break;}
         case 4055:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4056:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4057:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4058:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4059:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 4060:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4061:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4062:{StringError=" #"+DoubleToString(GLE,0)+",    string";break;}
         case 4063:{StringError=" #"+DoubleToString(GLE,0)+",    integer";break;}
         case 4064:{StringError=" #"+DoubleToString(GLE,0)+",    double";break;}
         case 4065:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4066:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 4067:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4068:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4069:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4070:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4071:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4072:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4073:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4074:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 4075:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 4099:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4100:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4101:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4102:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4103:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4104:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4105:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4106:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4107:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 4108:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4109:{StringError=" #"+DoubleToString(GLE,0)+",   .    (  )   ";break;}
         case 4110:{StringError=" #"+DoubleToString(GLE,0)+",     .    ";break;}
         case 4111:{StringError=" #"+DoubleToString(GLE,0)+",     .    ";break; }
         case 4112:{StringError=" #"+DoubleToString(GLE,0)+",     /    ";break;}
         case 4200:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4201:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4202:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4203:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4204:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4205:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4206:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4207:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 4210:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4211:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4212:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 4213:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4220:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 4250:{StringError=" #"+DoubleToString(GLE,0)+",   push-";break;}
         case 4251:{StringError=" #"+DoubleToString(GLE,0)+",   push-";break;}
         case 4252:{StringError=" #"+DoubleToString(GLE,0)+",  ";break;}
         case 4253:{StringError=" #"+DoubleToString(GLE,0)+",     push-";break;}
         case 4260:{StringError=" #"+DoubleToString(GLE,0)+",   FTP ";break;}
         case 4261:{StringError=" #"+DoubleToString(GLE,0)+",   FTP ";break;}
         case 4262:{StringError=" #"+DoubleToString(GLE,0)+",     FTP ";break;}
         case 4263:{StringError=" #"+DoubleToString(GLE,0)+",   FTP  ";break;}
         case 4264:{StringError=" #"+DoubleToString(GLE,0)+",  FTP       ";break;}
         case 4265:{StringError=" #"+DoubleToString(GLE,0)+",      MQL4"+CharToStr(92)+"Files    FTP ";break;}
         case 4266:{StringError=" #"+DoubleToString(GLE,0)+",      FTP ";break;}
         case 5001:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 5002:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5003:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 5004:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5005:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 5006:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5007:{StringError=" #"+DoubleToString(GLE,0)+",    (     )";break;}
         case 5008:{StringError=" #"+DoubleToString(GLE,0)+",    (    )";break;}
         case 5009:{StringError=" #"+DoubleToString(GLE,0)+",       FILE_WRITE";break;}
         case 5010:{StringError=" #"+DoubleToString(GLE,0)+",       FILE_READ";break;}
         case 5011:{StringError=" #"+DoubleToString(GLE,0)+",       FILE_BIN";break;}
         case 5012:{StringError=" #"+DoubleToString(GLE,0)+",       FILE_TXT";break;}
         case 5013:{StringError=" #"+DoubleToString(GLE,0)+",       FILE_TXT  FILE_CSV";break;}
         case 5014:{StringError=" #"+DoubleToString(GLE,0)+",       FILE_CSV";break;}
         case 5015:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5016:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5017:{StringError=" #"+DoubleToString(GLE,0)+",        ";break;}
         case 5018:{StringError=" #"+DoubleToString(GLE,0)+",    (  -TXT,   -BIN)";break;}
         case 5019:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5020:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5021:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 5022:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5023:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5024:{StringError=" #"+DoubleToString(GLE,0)+",     ";break;}
         case 5025:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5026:{StringError=" #"+DoubleToString(GLE,0)+",   ";break;}
         case 5027:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 5028:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 5029:{StringError=" #"+DoubleToString(GLE,0)+",      ";break;}
         case 5200:{StringError=" #"+DoubleToString(GLE,0)+", URL   ";break;}
         case 5201:{StringError=" #"+DoubleToString(GLE,0)+",      URL";break;}
         case 5202:{StringError=" #"+DoubleToString(GLE,0)+",    ";break;}
         case 5203:{StringError=" #"+DoubleToString(GLE,0)+",     HTTP ";break;}
        }
      Print(StringError);
     }}
//+------------------------------------------------------------------+
